;-----------------------------------------------------------------
;*****************************************************************
;*****************************************************************
;-----------------------------------------------------------------
ORG $20000
LOAD $20000
;-----------------------------------------------------------------
ST:
;----------------------------------------------------------------
	LEA	$30000,A0	; ERASE MEM
	MOVE.W	#$FFFE,D0
ERASE1:	MOVE.W	#0,(A0)+
DBRA	D0,ERASE1
;----------------------------------------------------------------
	CMP.W	#1,PASSE_ONE
	BEQ	NO_TRANS
	BSR	TRANSTEXT
NO_TRANS:
;----------------------------------------------------------------
	BSR	SAVE_ALL		; FORBID & SAVE POINTEURS
;----------------------------------------------------------------
BT1=$30000
	
	LEA	BT1,A3
	BSR	CONS_SCREEN

	LEA	$DFF000,A6	
	MOVE.W	#$7FFF,$9A(A6)	
	MOVE.W	#$7FFF,$96(A6)	
	MOVE.L	#$026439D1,$8E(A6)
	MOVE.W	#$1200,$100(A6)	
	CLR.L	$102(A6)	
	MOVE.L	#$00000000,$DFF108
	MOVE.L	#$003800D0,$92(A6)
	MOVE.L	#COPP,$DFF080
	CLR.W	$DFF088
;---------------------------------------------------------------
	MOVE.L	#IRQ,$6C	
	MOVE.W	#%1100000000010000,$9A(A6)
	MOVE.W	#%1000001111000000,$96(A6)
;---------------------------------------------------------------
ATTEN:				
	BTST	#6,$BFE001	
	BNE	ATTEN		
	BSR	RESTORE_ALL	
RTS
;----------------------------------------------------------------
IRQ:
	MOVE.L	D0,-(SP)	
	MOVE.W	$DFF01C,D0	
	AND.W	$DFF01E,D0	
	BTST	#4,D0		
	BEQ	FINIRQ		

	MOVE.W	#$10,$DFF09C
FINIRQ:
	MOVE.L	(SP)+,D0
RTE
;---------------------------------------------------------------
COMPTTEXT1:DC.W	-1
;---------------------------------------------------------------
LIS1:
;	CLR.L	D0
;	CMP.W	#0,COMPTEUR_SCROLLY1
;	BNE	FIN_FIN_FIN1

CONS_SCREEN:

	MOVE.W	#39,D4
BOUCLE1:
	LEA	TEXTE,A0

	ADD.W	#1,COMPTTEXT1
	MOVE.W	COMPTTEXT1,D0
	CLR.W	D1
	MOVE.B	(A0,D0.W),D1
	CMP.B	#$FF,D1
	BNE	CONT1
	MOVE.W	#-1,COMPTTEXT1
	BRA	FIN_FIN
CONT1:
	LEA	ADDRESSE,A4
	MULU	#2,D1

	MOVE.W	(A4,D1.W),ABS		; ABS=ADDRRESSE DANS LA FONTE

	LEA	FONT,A0
	ADD.W	ABS,A0

	MOVE.L	A3,A5
	MOVE.W	#7,D0
BOUCLE:
	MOVE.B	(A0)+,(A5)
	ADD.L	#40,A5
	DBRA	D0,BOUCLE

	ADD.L	#1,A3
DBRA	D4,BOUCLE1
	ADD.L	#40*9,A3
BRA	CONS_SCREEN

FIN_FIN:
RTS
;---------------------------------------------------------------
ABS:DC.W	0
;---------------------------------------------------------------
TRANSTEXT:
	CLR.L 	D0
	LEA 	CODETABLE,A0
	LEA	TEXTE,A1
	BSR	DO_TRANS

	MOVE.W	#1,PASSE_ONE
RTS
;---------------------------------------------------------------
DO_TRANS:
TT1:
	CLR.L	D1
	MOVE.B	(A1),D1
	MOVE.B 	(A0),D0
	CMP.B 	(A1),D0
	BNE 	TT2
	MOVE.B 	1(A0),(A1)
TT3:
	CMP.B 	#255,(A1)
	BEQ 	ENDTT
	LEA 	CODETABLE,A0
	ADD 	#1,A1
	BRA 	TT1
TT2:
	ADD 	#2,A0
	BRA TT1
ENDTT:
RTS
;---------------------------------------------------------------
PASSE_ONE:DC.W	0	; DEJA CONVERTI TEXT =1
;----------------------------------------------------------------
TEXTE:	       ;"                                        "
	DC.B	"                                        "
	DC.B	"                                        "
	DC.B	"                                        "
	DC.B	"                                        "
	DC.B	"****************************************"
	DC.B	"*                                      *"
	DC.B	"*  NOW REBOOTING MENU FROM MEMORY .    *"
	DC.B	"*                                      *"
	DC.B	"****************************************"
	DC.B	"                                        " 
	DC.B	" FEEL IT GOOD !!                        " 
	DC.B	"                                        " 
	DC.B	"                                        " 
	DC.B	"                                        " 
	DC.B	"                                        "
	DC.B	"****************************************"
	DC.B	"* CREDITS FOR THIS HAWK'S COMPILATION  *"
	DC.B	"* -----------------------------------  *"
	DC.B	"*                                      *"
	DC.B	"* CODES AND TRACKING  :   ORIENS       *"
	DC.B	"* FONTS AND GRAPHICS  :   ACES         *"
	DC.B	"* MUSIC AND SUPPORTS  :   TEBIROD      *"
	DC.B	"*                                      *"
	DC.B	"*       AND EUREKA,KREATOR,JOHNNY-B    *"
	DC.B	"****************************************"
	DC.B	$FF,$FF
;----------------------------------------------------------------
CODETABLE:
DC.B "A",0,"B",1,"C",2,"D",3,"E",4,"F",5,"G",6,"H",7,"I",8
DC.B "J",9,"K",10,"L",11,"M",12,"N",13,"O",14,"P",15,"Q",16
DC.B "R",17,"S",18,"T",19,"U",20,"V",21,"W",22,"X",23,"Y",24,"Z",25
DC.B "A",0,"B",1,"C",2,"D",3,"E",4,"F",5,"G",6,"H",7,"I",8
DC.B "J",9,"K",10,"L",11,"M",12,"N",13,"O",14,"P",15,"Q",16
DC.B "R",17,"S",18,"T",19,"U",20,"V",21,"W",22,"X",23,"Y",24,"Z",25

dc.b "a",0,"b",1,"c",2,"d",3,"e",4,"f",5,"g",6,"h",7,"i",8
dc.b "j",9,"k",10,"l",11,"m",12,"n",13,"o",14,"p",15,"q",16
dc.b "r",17,"s",18,"t",19,"u",20,"v",21,"w",22,"x",23,"y",24,"z",25
dc.b "a",0,"b",1,"c",2,"d",3,"e",4,"f",5,"g",6,"h",7,"i",8
dc.b "j",9,"k",10,"l",11,"m",12,"n",13,"o",14,"p",15,"q",16
dc.b "r",17,"s",18,"t",19,"u",20,"v",21,"w",22,"x",23,"y",24,"z",25

DC.B "0",26,"1",27,"2",28,"3",29,"4",30,"5",31,"6",32,"7",33,"8",34
DC.B "9",35,",",36,"'",37,".",38,":",39,"(",40,")",41,"[",42,"]",43
DC.B "?",44,"!",45,"/",46,"-",47," ",48,"*",49

DC.B 255,255
EVEN
ADDRESSE:
	DC.W	264,272,280,288,296,304,312,320,328,336,344,352,360
	DC.W	368,376,384,392,400,408,416,424,432,440,448,456,464
	DC.W	128,136,144,152,160,168,176,184,192,200
	DC.W	96,56,112,208,224,240,472,488,248,8,120,104,0,80

EVEN


RTS
;---------------------------------------------------------------
TEST:
	BTST	#6,$DFF002
	BNE	TEST
RTS
;---------------------------------------------------------------
SAVE_ALL:
	MOVE.B #$87,$BFD100		; STOP DRIVE
	MOVE.L $00000004,A6
	JSR -132(A6)

	MOVE.L $6C,SAVEIRQ
	MOVE.W $DFF01C,SAVEINT
	OR.W #$C000,SAVEINT
	MOVE.W $DFF002,SAVEDMA
	OR.W #$8100,SAVEDMA
RTS
RESTORE_ALL:
	MOVE.L SAVEIRQ,$6C
	MOVE.W #$7FFF,$DFF09A	
	MOVE.W SAVEINT,$DFF09A
	MOVE.W #$7FFF,$DFF096
	MOVE.W SAVEDMA,$DFF096
	MOVE.L $00000004,A6
	LEA NAME,A1
	MOVEQ #0,D0
	JSR -552(A6)

	MOVE.L D0,A0
	MOVE.L 38(A0),$DFF080
	CLR.W $DFF088
	MOVE.L D0,A1
	JSR -414(A6)
	JSR -138(A6)
RTS
;---------------------------------------------------------------
SAVEINT:DC.W 0
SAVEDMA:DC.W 0
SAVEIRQ:DC.L 0
NAME:DC.B "graphics.library",0
EVEN

COPP:		
		DC.L	$3001FFFE

		DC.L	$01800000,$01820FFF
		DC.L	$00E00003,$00E20000
		DC.L	$01001200

		DC.L	$009C8010,$FFFFFFFE	; END COPPER
;---------------------------------------------------------------
FONT:	BLK.B	768

>EXTERN	"DF1:FONTS8/G'N'G.FNT",FONT

