;-----------------------------------------------------------------
ORG $20000
LOAD $20000
;-----------------------------------------------------------------
ST:
;-----------------------------------------------------------------
	LEA	$40000,A0	; ERASE MEM
	MOVE.W	#$FFFE,D0
ERASE1:	MOVE.W	#0,(A0)+
DBRA	D0,ERASE1
;-----------------------------------------------------------------

BT1=$50000
BT2=$50000+36800
BT3=$50000+[36800*2]
BT4=$50000+[36800*3]
BT5=$50000+[36800*4]

	MOVE.W	#0,$DFF064
	MOVE.W	#36+46,$DFF066
	MOVE.L	#$09F00000,$DFF040
	MOVE.L	#$FFFFFFFF,$DFF044

	MOVE.L	#GRAPH1,$DFF050		
	MOVE.L	#BT1,$DFF054
	MOVE.W	#17*64+5,$DFF058
	BSR	TEST

	MOVE.L	#GRAPH1+[170*1],$DFF050		
	MOVE.L	#BT2,$DFF054
	MOVE.W	#17*64+5,$DFF058
	BSR	TEST

	MOVE.L	#GRAPH1+[170*2],$DFF050		
	MOVE.L	#BT3,$DFF054
	MOVE.W	#17*64+5,$DFF058
	BSR	TEST

	MOVE.L	#GRAPH1+[170*3],$DFF050		
	MOVE.L	#BT4,$DFF054
	MOVE.W	#17*64+5,$DFF058
	BSR	TEST

	MOVE.L	#GRAPH1+[170*4],$DFF050		
	MOVE.L	#BT5,$DFF054
	MOVE.W	#17*64+5,$DFF058
	BSR	TEST
;----------------------------------------------------------------
	BSR	SAVE_ALL		; FORBID & SAVE POINTEURS
;----------------------------------------------------------------
	LEA	$DFF000,A6	
	MOVE.W	#$7FFF,$9A(A6)	
	MOVE.W	#$7FFF,$96(A6)	
	MOVE.L	#$026439D1,$8E(A6)
	MOVE.W	#$0200,$100(A6)	
	CLR.L	$102(A6)	
	MOVE.L	#$002E002E,$DFF108
	MOVE.L	#$002A00D4,$92(A6)	; OVERSACN 46
	MOVE.L	#COPP,$DFF080
	CLR.W	$DFF088
;---------------------------------------------------------------
	MOVE.L	#IRQ,$6C	
	MOVE.W	#%1100000000010000,$9A(A6)
	MOVE.W	#%1000001111000000,$96(A6)
;---------------------------------------------------------------
ATTEN:				
	BTST	#6,$BFE001	
	BNE	ATTEN		
	BSR	RESTORE_ALL	
RTS
;----------------------------------------------------------------
IRQ:
	MOVE.L	D0,-(SP)	
	MOVE.W	$DFF01C,D0	
	AND.W	$DFF01E,D0	
	BTST	#4,D0		
	BEQ	FINIRQ		

	BSR	MOVE_IT

	MOVE.W	#$10,$DFF09C
FINIRQ:
	MOVE.L	(SP)+,D0
RTE
;---------------------------------------------------------------
COORD:	DC.W	0,0
COMPT1:	DC.W	0
MOVE_IT:
	CLR.L	D1
	CLR.L	D0
	CLR.L	D2

	MOVE.W	COMPT1,D0
	LEA	WAVE,A0
	MOVE.W	(A0,D0.W),D0

	CMP.W	#$FFFF,D0
	BNE	OK_GO
	MOVE.W	#0,COMPT1
	BRA	MOVE_IT
OK_GO:
	ADD.W	#2,COMPT1

	MOVE.W	#300,D1
	SUB.W	D0,D1	
	MOVE.W	D1,COORD+2

	ADD.W	#3,COORD

	MOVE.W	COORD+2,D2
	MULU	#46+46,D2	; TRAITEMENT DE L'ABSICSE *92

	MOVE.W	COORD,D0	; TRAITEMENT ABSISSE
	MOVE.W	D0,D1		; 
	LSR	#4,D0		; PREND PARTIE DIVISEE PAR 16
	LSL	#1,D0		; *2 POUR PASSER EN MOT
	
	AND.W	#$000F,D1	; PREND LE RESTE DIVISION

;	D0 ABSISSE ADDRESSE
;	D1 ABSISSE DECALAGE
;	D2 ORDONNEE	

	MOVE.W	#$10,D4
	ADD.W	D1,D4

	AND.W	#$000F,D4

	MOVE.W	D4,D1

	LSL	#4,D1
	OR.W	D1,D4


	MOVE.W	D4,DEC+2

	MOVE.L	#BT1,D3	
	SUB.L	D2,D3		; ENLEVE ORDONNEE
	SUB.L	D0,D3
	;---------------
	LEA	PT1,A0
	MOVE.W	D3,6(A0)
	SWAP	D3
	MOVE.W	D3,2(A0)

	MOVE.L	#BT2,D3	
	SUB.L	D2,D3		; ENLEVE ORDONNEE
	SUB.L	D0,D3
	;---------------
	LEA	PT2,A0
	MOVE.W	D3,6(A0)
	SWAP	D3
	MOVE.W	D3,2(A0)

	MOVE.L	#BT3,D3	
	SUB.L	D2,D3		; ENLEVE ORDONNEE
	SUB.L	D0,D3
	;---------------
	LEA	PT3,A0
	MOVE.W	D3,6(A0)
	SWAP	D3
	MOVE.W	D3,2(A0)

	MOVE.L	#BT4,D3	
	SUB.L	D2,D3		; ENLEVE ORDONNEE
	SUB.L	D0,D3
	;---------------
	LEA	PT4,A0
	MOVE.W	D3,6(A0)
	SWAP	D3
	MOVE.W	D3,2(A0)

	MOVE.L	#BT5,D3	
	SUB.L	D2,D3		; ENLEVE ORDONNEE
	SUB.L	D0,D3
	;---------------
	LEA	PT5,A0
	MOVE.W	D3,6(A0)
	SWAP	D3
	MOVE.W	D3,2(A0)
RTS
;---------------------------------------------------------------
TEST:
	BTST	#6,$DFF002
	BNE	TEST
RTS
;---------------------------------------------------------------
SAVE_ALL:
	MOVE.B #$87,$BFD100		; STOP DRIVE
	MOVE.L $00000004,A6
	JSR -132(A6)

	MOVE.L $6C,SAVEIRQ
	MOVE.W $DFF01C,SAVEINT
	OR.W #$C000,SAVEINT
	MOVE.W $DFF002,SAVEDMA
	OR.W #$8100,SAVEDMA
RTS
RESTORE_ALL:
	MOVE.L SAVEIRQ,$6C
	MOVE.W #$7FFF,$DFF09A	
	MOVE.W SAVEINT,$DFF09A
	MOVE.W #$7FFF,$DFF096
	MOVE.W SAVEDMA,$DFF096
	MOVE.L $00000004,A6
	LEA NAME,A1
	MOVEQ #0,D0
	JSR -552(A6)

	MOVE.L D0,A0
	MOVE.L 38(A0),$DFF080
	CLR.W $DFF088
	MOVE.L D0,A1
	JSR -414(A6)
	JSR -138(A6)
RTS
;---------------------------------------------------------------
SAVEINT:DC.W 0
SAVEDMA:DC.W 0
SAVEIRQ:DC.L 0
NAME:DC.B "graphics.library",0
EVEN

COPP:		
		DC.L	$01005200
DEC:		DC.L	$01020000

		DC.L	$01800000,$01820700,$01840900,$01860B00,$01880D00
		DC.L	$018A0F00,$018C0F44,$018E0F88
		DC.L	$01900FBB,$01920FFF,$0194099C,$01960AAD,$01980BBE
		DC.L	$019A0CCF,$019C0DDF,$019E0EEF

PT1:		DC.L	$00E00004,$00E20000
PT2:		DC.L	$00E40004,$00E60000
PT3:		DC.L	$00E80004,$00EA0000
PT4:		DC.L	$00EC0004,$00EE0000
PT5:		DC.L	$00F00004,$00F20000

		DC.L	$009C8010,$FFFFFFFE	; END COPPER
;---------------------------------------------------------------
WAVE:

GRAPH1:		BLK.B	850
GRAPH2:		BLK.B	1360
GRAPH3:		BLK.B	6860

>EXTERN "HAWK.BT",GRAPH1
;>EXTERN "PRESENT.BT",GRAPH2
;>EXTERN "THE.BT",GRAPH3

