;-----------------------------------------------------------------
;*****************************************************************
;*****************************************************************
;-----------------------------------------------------------------
	ORG $25000
	LOAD $25000
;-----------------------------------------------------------------
ST:

;----------------------------------------------------------------
	lea	$50000,a0
	lea	$80000,a1
erase:	clr.w	(a0)+
	cmp.l	a0,a1
	bne	erase
;----------------------------------------------------------------
BT1=$70000
;----------------------------------------------------------------
	BSR	SAVE_ALL		; FORBID & SAVE POINTEURS
;----------------------------------------------------------------
	LEA	$DFF000,A6	

;	MOVE.W	#$7FFF,$9A(A6)	
;	MOVE.W	#$7FFF,$96(A6)	

	MOVE.L	#$026439D1,$8E(A6)
	MOVE.W	#$1200,$100(A6)	
	CLR.L	$102(A6)	
	MOVE.L	#$00000000,$DFF108
	MOVE.L	#$003800D0,$92(A6)
	MOVE.L	#COPP,$DFF080
	CLR.W	$DFF088
;---------------------------------------------------------------
	move.l	#irq,$6c

	MOVE.W #$7FFF,$DFF09A	; clr interupts

	MOVE.W	#%1000000000100000,$DFF09a	; ET REMET
		; 8421842184218421

	MOVE.W	#%0011111111111111,$DFF096	; CLEAR
		; 8421842184218421
	MOVE.W	#%1000011111110000,$DFF096	; ET REMET
		; 8421842184218421
;---------------------------------------------------------------
wait:	
	btst	#6,$bfe001
	bne	wait
	bra	suite


LOAD_TRACK:
	MOVE.L	EXECBASE,A6
	SUB.L 	A1,A1
	JSR 	FINDTASK(A6)
	MOVE.L 	D0,READREPLY+$10
	
	LEA 	READREPLY,A1
	JSR 	ADDPORT(A6)

	LEA 	DISKIO,A1
	MOVE.L 	#0,D0
	CLR.L 	D1
	LEA 	TRDDEVICE,A0
	JSR 	OPENDEV(A6)
	TST.L 	D0
	BNE	ERROR
	
	MOVE.L	#239*$200,D4	; TAILLE

	MOVE.L	#1000*512,D5	; POSITION
OK_LOAD:
	LEA 	DISKIO,A1
	MOVE.L 	#READREPLY,14(A1)
	MOVE 	#2,28(A1)
	MOVE.L 	#$50000,$28(A1)

	MOVE.L 	D4,$24(A1)
	MOVE.L 	D5,$2C(A1)
	MOVE.L 	EXECBASE,A6
	JSR 	DOIO(A6)

	MOVE.L 	DISKIO+32,D6
	LEA 	DISKIO,A1
	MOVE 	#9,28(A1)
	MOVE.L 	#0,36(A1)
	JSR 	DOIO(A6)

	LEA 	READREPLY,A1
	JSR	REMPORT(A6)

	LEA 	DISKIO,A1
	JSR 	CLOSEDEV(A6)

;NO_BOUCLE:


suite:
	bsr	restore_all
	rts

;	JMP	$21000
ERROR:
	RTS
;----------------------------------------------------------------
EXECBASE=4
FINDTASK=-294
ADDPORT=-354
REMPORT=-360
OPENLIB=-408
CLOSELIB=-414
OPENDEV=-444
CLOSEDEV=-450
DOIO=-456
TRDDEVICE:	DC.B	'trackdisk.device',0
	EVEN
;----------------------------------------------------------------
DISKIO:		BLK.L	20,0
READREPLY:	BLK.L	8,0
;----------------------------------------------------------------
PROUT:
ATTEN:				
	BTST	#6,$BFE001	
	BNE	ATTEN		
	BSR	RESTORE_ALL	
	RTS
;----------------------------------------------------------------
IRQ:	MOVE.L	D0,-(SP)	

	MOVE.W	$DFF01C,D0	
	AND.W	$DFF01E,D0	
	BTST	#4,D0		
	BEQ	FINIRQ		

	move.b	$dff006,$dff180

	MOVE.W	#$10,$DFF09C
FINIRQ:	MOVE.L	(SP)+,D0
	RTE
;---------------------------------------------------------------
SAVE_ALL:
;	MOVE.B #$87,$BFD100		; STOP DRIVE

	MOVE.L $00000004,A6
	JSR -132(A6)

	MOVE.L $6C,SAVEIRQ
	MOVE.W $DFF01C,SAVEINT
	OR.W #$C000,SAVEINT
	MOVE.W $DFF002,SAVEDMA
	OR.W #$8100,SAVEDMA
	RTS

RESTORE_ALL:
	MOVE.L SAVEIRQ,$6C
	MOVE.W #$7FFF,$DFF09A	

	MOVE.W SAVEINT,$DFF09A
	MOVE.W #$7FFF,$DFF096

	MOVE.W SAVEDMA,$DFF096
	MOVE.L $00000004,A6

	LEA NAME,A1
	MOVEQ #0,D0
	JSR -552(A6)

	MOVE.L D0,A0
	MOVE.L 38(A0),$DFF080
	CLR.W $DFF088

	MOVE.L D0,A1
	JSR -414(A6)
	JSR -138(A6)
	RTS
;---------------------------------------------------------------
SAVEINT:DC.W 0
SAVEDMA:DC.W 0
SAVEIRQ:DC.L 0
NAME:DC.B "graphics.library",0
	EVEN

COPP:		
		DC.L	$3001FFFE

		DC.L	$01800000,$01820FFF
		DC.L	$00E00005,$00E20000
		DC.L	$01001200,$00960020

		DC.L	$009C8010,$FFFFFFFE	; END COPPER
;---------------------------------------------------------------
FONT:	BLK.B	768

END:
>EXTERN	"DF1:FONTS8/G'N'G.FNT",FONT
