;-----------------------------------------------------------------
ORG $20000
LOAD $20000
;-----------------------------------------------------------------
ST:
;-----------------------------------------------------------------
	LEA	$3E000,A0	; ERASE MEM
	MOVE.W	#$FFFE,D0
ERASE1:	MOVE.L	#0,(A0)+
DBRA	D0,ERASE1
;-----------------------------------------------------------------
	MOVE.L	#0,D0
	MOVE.L	#0,D1
	MOVE.L	#0,D2

	BSR	PUT_IT

BT1=$40000
BT2=$40000+42000
BT3=$40000+[42000*2]
BT4=$40000+[42000*3]
BT5=$40000+[42000*4]

;----------------------------------------------------------------
	BSR	SAVE_ALL		; FORBID & SAVE POINTEURS
;----------------------------------------------------------------
	LEA	$DFF000,A6	
	MOVE.W	#$7FFF,$9A(A6)	
	MOVE.W	#$7FFF,$96(A6)	
	MOVE.L	#$026439D1,$8E(A6)
	MOVE.W	#$0200,$100(A6)	
	CLR.L	$102(A6)	
	MOVE.L	#$002E002E,$DFF108
	MOVE.L	#$002A00D4,$92(A6)	; OVERSCAN 46
	MOVE.L	#COPP,$DFF080
	CLR.W	$DFF088
;---------------------------------------------------------------
	MOVE.L	#IRQ,$6C	
	MOVE.W	#%1100000000010000,$9A(A6)
	MOVE.W	#%1000001111000000,$96(A6)
;---------------------------------------------------------------
	BSR	PREPARE_HAWK
;---------------------------------------------------------------
ATTEN:				
	CMP.W	#1,END_IT
	BEQ	EE

	BTST	#6,$BFE001	
	BNE	ATTEN		
EE:
	BSR	RESTORE_ALL	
LOAD_TRACK:
	MOVE.L	EXECBASE,A6
	SUB.L 	A1,A1
	JSR 	FINDTASK(A6)
	MOVE.L 	D0,READREPLY+$10
	
	LEA 	READREPLY,A1
	JSR 	ADDPORT(A6)

	LEA 	DISKIO,A1
	MOVE.L 	#0,D0
	CLR.L 	D1
	LEA 	TRDDEVICE,A0
	JSR 	OPENDEV(A6)
	TST.L 	D0
	BNE	ERROR
	
	MOVE.L	#100*$200,D4	; TAILLE
	MOVE.L	#13*512,D5	; POSITION
OK_LOAD:
	LEA 	DISKIO,A1
	MOVE.L 	#READREPLY,14(A1)
	MOVE 	#2,28(A1)
	MOVE.L 	#$4200,$28(A1)

	MOVE.L 	D4,$24(A1)
	MOVE.L 	D5,$2C(A1)
	MOVE.L 	EXECBASE,A6
	JSR 	DOIO(A6)

	MOVE.L 	DISKIO+32,D6
	LEA 	DISKIO,A1
	MOVE 	#9,28(A1)
	MOVE.L 	#0,36(A1)
	JSR 	DOIO(A6)

	LEA 	READREPLY,A1
	JSR	REMPORT(A6)

	LEA 	DISKIO,A1
	JSR 	CLOSEDEV(A6)

;	JMP	$6200
ERROR:
	RTS
EXECBASE=4
FINDTASK=-294
ADDPORT=-354
REMPORT=-360
OPENLIB=-408
CLOSELIB=-414
OPENDEV=-444
CLOSEDEV=-450
DOIO=-456
;----------------------------------------------------------------
;LABELS POUR COPPER
;----------------------------------------------------------------
GFXBASE:	DC.L	0
COPPTR:		DC.L	0
OLDCOP:		DC.L	0
;----------------------------------------------------------------
TRDDEVICE:	DC.B	'trackdisk.device',0
EVEN
;----------------------------------------------------------------
DISKIO:		BLK.L	20,0
READREPLY:	BLK.L	8,0
;----------------------------------------------------------------
KEL:	DC.W	0
;----------------------------------------------------------------
IRQ:
	MOVE.L	D0,-(SP)	
	MOVE.W	$DFF01C,D0	
	AND.W	$DFF01E,D0	
	BTST	#4,D0		
	BEQ	FINIRQ		

	CMP	#0,KEL
	BNE	PAS_CA
	BSR	MOVE_IT
PAS_CA:
	CMP	#1,KEL
	BNE	TJR_PAS
	BSR	MOVE_IT1
TJR_PAS:
	CMP.W	#2,KEL
	BNE	BEN_NON
	BSR	MOVE_IT2
BEN_NON:
	CMP.W	#3,KEL
	BNE	NON_NON	
	MOVE.W	#1,END_IT
NON_NON:

	MOVE.W	#$10,$DFF09C
FINIRQ:
	MOVE.L	(SP)+,D0
RTE
;---------------------------------------------------------------
END_IT:DC.W	0
PREPARE_HAWK:
	MOVE.W	#0,$DFF064
	MOVE.W	#36+46,$DFF066
	MOVE.L	#$09F00000,$DFF040
	MOVE.L	#$FFFFFFFF,$DFF044

	MOVE.L	#GRAPH1,$DFF050		
	MOVE.L	#BT1-[17*46*2],$DFF054
	MOVE.W	#17*64+5,$DFF058
	BSR	TEST
			
	MOVE.L	#GRAPH1+[170*1],$DFF050		
	MOVE.L	#BT2-[17*46*2],$DFF054
	MOVE.W	#17*64+5,$DFF058
	BSR	TEST
			
	MOVE.L	#GRAPH1+[170*2],$DFF050		
	MOVE.L	#BT3-[17*46*2],$DFF054
	MOVE.W	#17*64+5,$DFF058
	BSR	TEST
			
	MOVE.L	#GRAPH1+[170*3],$DFF050		
	MOVE.L	#BT4-[17*46*2],$DFF054
	MOVE.W	#17*64+5,$DFF058
	BSR	TEST
			
	MOVE.L	#GRAPH1+[170*4],$DFF050		
	MOVE.L	#BT5-[17*46*2],$DFF054
	MOVE.W	#17*64+5,$DFF058
	BSR	TEST
RTS
;---------------------------------------------------------------
PREPARE_PRESENT:
	MOVE.W	#0,$DFF064
	MOVE.W	#30+46,$DFF066
	MOVE.L	#$09F00000,$DFF040
	MOVE.L	#$FFFFFFFF,$DFF044

	MOVE.L	#GRAPH2,$DFF050		
	MOVE.L	#BT1-[17*46*2],$DFF054
	MOVE.W	#17*64+8,$DFF058
	BSR	TEST
			
	MOVE.L	#GRAPH2+[272*1],$DFF050		
	MOVE.L	#BT2-[17*46*2],$DFF054
	MOVE.W	#17*64+8,$DFF058
	BSR	TEST
			
	MOVE.L	#GRAPH2+[272*2],$DFF050		
	MOVE.L	#BT3-[17*46*2],$DFF054
	MOVE.W	#17*64+8,$DFF058
	BSR	TEST
				
	MOVE.L	#GRAPH2+[272*3],$DFF050		
	MOVE.L	#BT4-[17*46*2],$DFF054
	MOVE.W	#17*64+8,$DFF058
	BSR	TEST
			
	MOVE.L	#GRAPH2+[272*4],$DFF050		
	MOVE.L	#BT5-[17*46*2],$DFF054
	MOVE.W	#17*64+8,$DFF058
	BSR	TEST
RTS
;---------------------------------------------------------------
PREPARE_THE:
	MOVE.W	#0,$DFF064
	MOVE.W	#18+46,$DFF066
	MOVE.L	#$09F00000,$DFF040
	MOVE.L	#$FFFFFFFF,$DFF044

	MOVE.L	#GRAPH3,$DFF050		
	MOVE.L	#BT1-[49*46*2],$DFF054
	MOVE.W	#49*64+14,$DFF058
	BSR	TEST
			
	MOVE.L	#GRAPH3+[1372*1],$DFF050		
	MOVE.L	#BT2-[49*46*2],$DFF054
	MOVE.W	#49*64+14,$DFF058
	BSR	TEST
			
	MOVE.L	#GRAPH3+[1372*2],$DFF050		
	MOVE.L	#BT3-[49*46*2],$DFF054
	MOVE.W	#49*64+14,$DFF058
	BSR	TEST
				
	MOVE.L	#GRAPH3+[1372*3],$DFF050		
	MOVE.L	#BT4-[49*46*2],$DFF054
	MOVE.W	#49*64+14,$DFF058
	BSR	TEST
			
	MOVE.L	#GRAPH3+[1372*4],$DFF050		
	MOVE.L	#BT5-[49*46*2],$DFF054
	MOVE.W	#49*64+14,$DFF058
	BSR	TEST
RTS
;---------------------------------------------------------------
COORD:	DC.W	00,0
COMPT1:	DC.W	0
MOVE_IT:
	CLR.L	D1
	CLR.L	D0
	CLR.L	D2

	MOVE.W	COMPT1,D0
	LEA	WAVE,A0
	MOVE.W	(A0,D0.W),D0

	CMP.W	#$FFFF,D0
	BNE	OK_GO

	MOVE.L	#0,D0
	MOVE.L	#0,D1
	MOVE.L	#0,D2
	BSR	PUT_IT

	BSR	PREPARE_PRESENT
	MOVE.W	#1,KEL
	MOVE.W	#0,COMPT1

	MOVE.W	#0,COORD

	BRA	END1
OK_GO:
	ADD.W	#2,COMPT1

	LSR	#1,D1
	MOVE.W	#599,D1
	SUB.W	D0,D1	
	MOVE.W	D1,COORD+2

	ADD.W	#2,COORD

	MOVE.W	COORD+2,D2
	MULU	#46+46,D2	; TRAITEMENT DE L'ABSICSE *92

	MOVE.W	COORD,D0	; TRAITEMENT ABSISSE
	MOVE.W	D0,D1		; 
	LSR	#4,D0		; PREND PARTIE DIVISEE PAR 16
	LSL	#1,D0		; *2 POUR PASSER EN MOT
	
	AND.W	#$000F,D1	; PREND LE RESTE DIVISION

;	D0 ABSISSE ADDRESSE
;	D1 ABSISSE DECALAGE
;	D2 ORDONNEE	

	BSR	PUT_IT
END1:
RTS
MOVE_IT1:
	CLR.L	D1
	CLR.L	D0
	CLR.L	D2

	MOVE.W	COMPT1,D0
	LEA	WAVE,A0
	MOVE.W	(A0,D0.W),D0

	CMP.W	#$FFFF,D0
	BNE	OK_GO1

;	MOVE.L	#0,D0
;	MOVE.L	#0,D1
;	MOVE.L	#0,D2
;	BSR	PUT_IT

	BSR	PREPARE_THE

	MOVE.W	#2,KEL
	MOVE.W	#0,COMPT1
	
	MOVE.W	#0,COORD

	BRA	END2
OK_GO1:
	ADD.W	#2,COMPT1

	LSR	#1,D1
	MOVE.W	#600,D1
	SUB.W	D0,D1	
	MOVE.W	D1,COORD+2

	ADD.W	#2,COORD

	MOVE.W	COORD+2,D2
	MULU	#46+46,D2	; TRAITEMENT DE L'ABSICSE *92

	MOVE.W	COORD,D0	; TRAITEMENT ABSISSE
	MOVE.W	D0,D1		; 
	LSR	#4,D0		; PREND PARTIE DIVISEE PAR 16
	LSL	#1,D0		; *2 POUR PASSER EN MOT
	
	AND.W	#$000F,D1	; PREND LE RESTE DIVISION

;	D0 ABSISSE ADDRESSE
;	D1 ABSISSE DECALAGE
;	D2 ORDONNEE	

	BSR	PUT_IT
END2:
RTS
MOVE_IT2:
	CLR.L	D1
	CLR.L	D0
	CLR.L	D2

	MOVE.W	COMPT1,D0
	LEA	WAVE1,A0
	MOVE.W	(A0,D0.W),D0

	CMP.W	#$FFFF,D0
	BNE	OK_GO3

	MOVE.W	#3,KEL
	MOVE.W	#0,COMPT1
	BRA	END3
OK_GO3:
	ADD.W	#2,COMPT1

	LSR	#1,D1
	MOVE.W	#600,D1
	SUB.W	D0,D1	
	MOVE.W	D1,COORD+2

	ADD.W	#2,COORD

	MOVE.W	COORD+2,D2
	MULU	#46+46,D2	; TRAITEMENT DE L'ABSICSE *92

	MOVE.W	COORD,D0	; TRAITEMENT ABSISSE
	MOVE.W	D0,D1		; 
	LSR	#4,D0		; PREND PARTIE DIVISEE PAR 16
	LSL	#1,D0		; *2 POUR PASSER EN MOT
	
	AND.W	#$000F,D1	; PREND LE RESTE DIVISION

;	D0 ABSISSE ADDRESSE
;	D1 ABSISSE DECALAGE
;	D2 ORDONNEE	

	BSR	PUT_IT
END3:
RTS

PUT_IT:
	MOVE.W	#$10,D4
	ADD.W	D1,D4

	AND.W	#$000F,D4

	MOVE.W	D4,D1

	LSL	#4,D1
	OR.W	D1,D4

	MOVE.W	D4,DEC+2

	MOVE.L	#BT1,D3	
	SUB.L	D2,D3		; ENLEVE ORDONNEE
	SUB.L	D0,D3
	;---------------
	LEA	PT1,A0
	MOVE.W	D3,6(A0)
	SWAP	D3
	MOVE.W	D3,2(A0)

	MOVE.L	#BT2,D3	
	SUB.L	D2,D3		; ENLEVE ORDONNEE
	SUB.L	D0,D3
	;---------------
	LEA	PT2,A0
	MOVE.W	D3,6(A0)
	SWAP	D3
	MOVE.W	D3,2(A0)

	MOVE.L	#BT3,D3	
	SUB.L	D2,D3		; ENLEVE ORDONNEE
	SUB.L	D0,D3
	;---------------
	LEA	PT3,A0
	MOVE.W	D3,6(A0)
	SWAP	D3
	MOVE.W	D3,2(A0)

	MOVE.L	#BT4,D3	
	SUB.L	D2,D3		; ENLEVE ORDONNEE
	SUB.L	D0,D3
	;---------------
	LEA	PT4,A0
	MOVE.W	D3,6(A0)
	SWAP	D3
	MOVE.W	D3,2(A0)

	MOVE.L	#BT5,D3	
	SUB.L	D2,D3		; ENLEVE ORDONNEE
	SUB.L	D0,D3
	;---------------
	LEA	PT5,A0
	MOVE.W	D3,6(A0)
	SWAP	D3
	MOVE.W	D3,2(A0)
RTS
;---------------------------------------------------------------
TEST:
	BTST	#6,$DFF002
	BNE	TEST
RTS
;---------------------------------------------------------------
SAVE_ALL:
;	MOVE.B #$87,$BFD100		; STOP DRIVE
;	MOVE.L $00000004,A6
;	JSR -132(A6)

	MOVE.L $6C,SAVEIRQ
	MOVE.W $DFF01C,SAVEINT
	OR.W #$C000,SAVEINT
	MOVE.W $DFF002,SAVEDMA
	OR.W #$8100,SAVEDMA
RTS
RESTORE_ALL:
	MOVE.L SAVEIRQ,$6C
	MOVE.W #$7FFF,$DFF09A	
	MOVE.W SAVEINT,$DFF09A
	MOVE.W #$7FFF,$DFF096
	MOVE.W SAVEDMA,$DFF096
	MOVE.L $00000004,A6
	LEA NAME,A1
	MOVEQ #0,D0
	JSR -552(A6)

	MOVE.L D0,A0
;	MOVE.L 38(A0),$DFF080
;	CLR.W $DFF088

	MOVE.L D0,A1
	JSR -414(A6)
;	JSR -138(A6)
RTS
;---------------------------------------------------------------
SAVEINT:DC.W 0
SAVEDMA:DC.W 0
SAVEIRQ:DC.L 0
NAME:DC.B "graphics.library",0
EVEN

COPP:		
		DC.L	$01005200
DEC:		DC.L	$01020000

DC.L		$1601FFFE
		DC.L	$01800000,$01820700,$01840900,$01860B00,$01880D00
		DC.L	$018A0F00,$018C0F44,$018E0F88
		DC.L	$01900FBB,$01920FFF,$0194099C,$01960AAD,$01980BBE
		DC.L	$019A0CCF,$019C0DDF,$019E0EEF
DC.L		$1701FFFE
;		DC.L	$01200004,$01220000


PT1:		DC.L	$00E00004,$00E20000
PT2:		DC.L	$00E40004,$00E60000
PT3:		DC.L	$00E80004,$00EA0000
PT4:		DC.L	$00EC0004,$00EE0000
PT5:		DC.L	$00F00004,$00F20000

		DC.L	$009C8010,$FFFFFFFE	; END COPPER
;---------------------------------------------------------------
WAVE:
	DC.W	$0257,$0257,$0257,$0256
	DC.W	$0256,$0255,$0254,$0253
	DC.W	$0252,$0250,$024F,$024D
	DC.W	$024C,$024A,$0248,$0246
	DC.W	$0244,$0241,$023F,$023C
	DC.W	$023A,$0237,$0234,$0231
	DC.W	$022E,$022A,$0227,$0224
	DC.W	$0220,$021C,$0219,$0215
	DC.W	$0211,$020D,$0208,$0204
	DC.W	$0200,$01FB,$01F7,$01F2
	DC.W	$01ED,$01E8,$01E3,$01DE
	DC.W	$01D9,$01D4,$01CF,$01CA
	DC.W	$01C4,$01BF,$01B9,$01B4
	DC.W	$01AE,$01A8,$01A3,$019D
	DC.W	$0197,$0191,$018B,$0185
	DC.W	$017F,$0179,$0173,$016D
	DC.W	$0167,$0161,$015A,$0154
	DC.W	$014E,$0148,$0141,$013B
	DC.W	$0135,$012F,$0128,$0122
	DC.W	$011C,$0116,$010F,$0109

	DC.W	$FFFF
WAVE1:
	DC.W	$0257,$0257,$0257,$0256
	DC.W	$0256,$0255,$0254,$0253
	DC.W	$0252,$0250,$024F,$024D
	DC.W	$024C,$024A,$0248,$0246
	DC.W	$244,$241,$23F,$23C
	DC.W	$23A,$237,$234,$231,$22E,$22A,$227,$224
	DC.W	$220,$21C,$219,$215,$211,$20D,$208,$204
	DC.W	$200,$1FB,$1F7,$1F2,$1ED,$1E8,$1E3,$1DE
	DC.W	$1D9,$1D4,$1CF,$1CA,$1C4,$1BF,$1B9,$1B4
	DC.W	$1AE,$1A8,$1A3,$19D,$197,$191,$18B,$185
	DC.W	$17F,$179,$173,$16D,$167,$161,$15A,$154

	DC.W	$15A,$161,$167,$16D,$173,$179,$17F,$185,$18B,$191,$197
	DC.W	$19D,$1A3,$1A8,$1AE,$1B4,$1B9,$1BF,$1C4,$1CA,$1CF,$1D4
	DC.W	$1D9,$1DE,$1E3,$1E8,$1ED,$1F2,$1F7,$1FB,$200,$204,$208
	DC.W	$20D,$211,$215,$219,$21C,$220,$224,$227,$22A,$22E
	DC.W	$231,$234,$237,$23A,$23C,$23F,$241,$244,$246,$248,$24A
	DC.W	$24C,$24D,$24F,$250,$252,$253,$254,$255,$256,$256,$257
	DC.W	$257


	DC.W	$FFFF

GRAPH1:		BLK.B	850
GRAPH2:		BLK.B	1360
GRAPH3:		BLK.B	6860

END:
>EXTERN "G/HAWK.BT",GRAPH1
>EXTERN "G/PRESENT.BT",GRAPH2
>EXTERN "G/THE.BT",GRAPH3

