;-----------------------------------------------------------------
;*****************************************************************
;	THE REMEMBER COLLECTION BY ORIENS/HAWK
;	WITH THE HELP OF THE NEW CONCEPT	
;*****************************************************************
;-----------------------------------------------------------------
ORG $50000
LOAD $50000
;-----------------------------------------------------------------
ST:
	BSR	SAVE_ALL		; FORBID & SAVE POINTEURS
;----------------------------------------------------------------
	LEA	$DFF000,A6	
	MOVE.W	#$7FFF,$9A(A6)	
	MOVE.W	#$7FFF,$96(A6)	
	MOVE.L	#$1A7039C7,$8E(A6)
	CLR.L	$102(A6)	
	MOVE.L	#$00000000,$DFF108
	MOVE.L	#$003800D0,$92(A6)
	MOVE.L	#COPP,$DFF080
	CLR.W	$DFF088
;---------------------------------------------------------------
;	MOVE.L	#IRQ,$6C	

;	MOVE.W	#%1100000000010000,$9A(A6)
;	MOVE.W	#%1000011111100000,$96(A6)
;---------------------------------------------------------------
ATTEN:				
	BTST	#6,$BFE001	
	BNE	ATTEN		

	BSR	RESTORE_ALL	
RTS
;----------------------------------------------------------------
;----------------------------------------------------------------
;			IRQ
;----------------------------------------------------------------
;----------------------------------------------------------------
IRQ:
	MOVEM.L	D0-D7/A0-A7,-(SP)	
	MOVE.W	$DFF01C,D0	
	AND.W	$DFF01E,D0	
	BTST	#4,D0		
	BEQ	FINIRQ		


	MOVE.W	#$10,$DFF09C
FINIRQ:
	MOVEM.L	(SP)+,D0-D7/A0-A7
RTE
;---------------------------------------------------------------
SAVE_ALL:
	MOVE.B #$87,$BFD100		; STOP DRIVE
	MOVE.L $00000004,A6
	JSR -132(A6)

	MOVE.L $6C,SAVEIRQ
	MOVE.W $DFF01C,SAVEINT
	OR.W #$C000,SAVEINT
	MOVE.W $DFF002,SAVEDMA
	OR.W #$8100,SAVEDMA
RTS
RESTORE_ALL:
	MOVE.L SAVEIRQ,$6C
	MOVE.W #$7FFF,$DFF09A	
	MOVE.W SAVEINT,$DFF09A
	MOVE.W #$7FFF,$DFF096
	MOVE.W SAVEDMA,$DFF096
	MOVE.L $00000004,A6
	LEA NAME,A1
	MOVEQ #0,D0
	JSR -552(A6)

	MOVE.L D0,A0
	MOVE.L 38(A0),$DFF080
	CLR.W $DFF088
	MOVE.L D0,A1
	JSR -414(A6)

	JSR -138(A6)
RTS
;---------------------------------------------------------------
SAVEINT:DC.W 0
SAVEDMA:DC.W 0
SAVEIRQ:DC.L 0
NAME:DC.B "graphics.library",0
EVEN

COPP:		
		DC.L	$01800000,$01820FD9,$01840CA7,$01860EC8,$01880DB7
		DC.L	$018A0DA6,$018C0C95,$018E0B84
		DC.L	$01900B74,$01920A64,$01940DFD,$01960ADC,$019806B9
		DC.L	$019A0387,$019C0165,$019E0043

		DC.L	$01A00FFF,$01A2000F,$01A4000B,$01A60009,$01A80000
		DC.L	$01AA0000,$01AC0000,$01AE0000
		DC.L	$01B00000,$01B20000,$01B40000,$01B60000,$01B80000
		DC.L	$01BA0000,$01BC0000,$01BE0000

		DC.L	$150FFFFE,$01000200

		DC.L	$009C8010,$FFFFFFFE	; END COPPER


