;-----------------------------------------------------------------
;	/--||--\ /------\/-\        /-\/--\  /-\ Oriens/1991-92
;       |  ||  | |      |\  \      /  /|  | /  /
;       |  --  | |  ==  | \  \    /  / |  |/  /
;       |  --  | |      |  \  \/\/  /  |     |
;       |  ||  | |  ||  |   \      /   |  |\  \ 
;       \--||--/ \--/\--/    \----/    \--/ \--\
;
;	Intro Hawk Compil 'The Remember Collection'	
;
;	LE 07/11/91
;-----------------------------------------------------------------
	ORG $20000
	LOAD $20000
;-----------------------------------------------------------------
ST:
;----------------------------------------------------------------
	BSR.W	SAVE_ALL		; FORBID & SAVE POINTEURS
;----------------------------------------------------------------
	bsr	put_point

	LEA	$DFF000,A6	
	MOVE.W	#$7FFF,$9A(A6)	
	MOVE.W	#$7FFF,$96(A6)	
	MOVE.L	#$387018C1,$8E(A6)
	CLR.L	$102(A6)	
	MOVE.L	#$00000000,$DFF108
	MOVE.L	#$003800D0,$92(A6)
	MOVE.L	#COPP,$DFF080
	CLR.W	$DFF088
;---------------------------------------------------------------
	MOVE.L	#IRQ,$6C	

	MOVE.W	#%1100000000010000,$9A(A6)
	MOVE.W	#%1000011111110000,$96(A6)
;---------------------------------------------------------------
ATTEN:	
	cmp.b	#1,end_ok
	beq	end

	BTST	#6,$BFE001	
	BNE.B	ATTEN		

end:	BSR.W	RESTORE_ALL	
	RTS
;----------------------------------------------------------------
;			IRQ
;----------------------------------------------------------------
End_ok:		dc.b	0	; fin =1
	even
Compt_all:	dc.l	0	; Compteur general
;----------------------------------------------------------------
Irq:
	MOVEM.L	D0-D7/A0-A7,-(SP)	
	MOVE.W	$DFF01C,D0	
	AND.W	$DFF01E,D0	
	BTST	#4,D0		
	BEQ.W	FINIRQ		

	add.l	#1,compt_all

	cmp.l	#20,compt_all
	bne.B	no_effet2
	bsr.w	init_slide_up16
	bra.w	do
no_effet2:		
	cmp.l	#250,compt_all
	bne.B	no_effet6
	bsr.w	init_slide_down16
	bra.w	do
no_effet6:		
	cmp.l	#290,compt_all
	bne.b	bo_end
	move.b	#1,end_ok
bo_end:	

do:
	cmp.b	#1,slide_up_ok16
	bne.B	no_slide_up16
	bsr.w	slide_up16
no_slide_up16:	
	cmp.b	#1,slide_down_ok16
	bne.B	no_slide_down16
	bsr.w	slide_down16
no_slide_down16:	

	MOVE.W	#$10,$DFF09C
FINIRQ:
	MOVEM.L	(SP)+,D0-D7/A0-A7
	RTE
;---------------------------------------------------------------
Put_point:
	lea	pt1,a0
	move.l	#pic,d0
	move.w	d0,6(a0)
	swap	d0
	move.w	d0,2(a0)

	lea	pt2,a0
	move.l	#pic+[10240*1],d0
	move.w	d0,6(a0)
	swap	d0
	move.w	d0,2(a0)

	lea	pt3,a0
	move.l	#pic+[10240*2],d0
	move.w	d0,6(a0)
	swap	d0
	move.w	d0,2(a0)

	lea	pt4,a0
	move.l	#pic+[10240*3],d0
	move.w	d0,6(a0)
	swap	d0
	move.w	d0,2(a0)

	lea	pt5,a0
	move.l	#pic+[10240*4],d0
	move.w	d0,6(a0)
	swap	d0
	move.w	d0,2(a0)


	rts
;---------------------------------------------------------------
slide_up_ok16:	dc.b	0
slide_down_ok16:dc.b	0
	even
tempo:		dc.w	0
slide_compt16:	dc.w	0

init_slide_up16:
	clr.w	slide_compt16
	clr.w	tempo
	move.b	#1,slide_up_ok16
	rts
init_slide_down16:
	clr.w	slide_compt16
	move.b	#1,slide_down_ok16
	rts


slide_up16:		; long ; long[0000 et col]
	add.w	#1,tempo
	cmp.w	#3,tempo
	bne.w	no_end_up16
	clr.w	tempo

	move.w	slide_compt16,d0
	move.w	#31,d5
	move.l	#copp,a0
	lea	pal,a1
boucle16:
	move.w	2(a0),d1
	move.w	(a1),d2

	and.w	#$000f,d1
	and.w	#$000f,d2
	cmp.w	d1,d2
	beq.B	no_11
	add.w	#0001,2(a0)
no_11:	
	move.w	2(a0),d1
	move.w	(a1),d2
	and.w	#$00f0,d1
	and.w	#$00f0,d2
	cmp.w	d1,d2
	beq.B	no_21
	add.w	#$0010,2(a0)
no_21:	
	move.w	2(a0),d1
	move.w	(a1),d2
	and.w	#$0f00,d1
	and.w	#$0f00,d2
	cmp.w	d1,d2
	beq.B	no_31
	add.w	#$0100,2(a0)
no_31:

	add.l	#4,a0
	add.l	#2,a1

	dbra	d5,boucle16

	add.w	#1,slide_compt16
	cmp.w	#16,slide_compt16		
	bne.b	no_end_up16
	move.b	#0,slide_up_ok16
no_end_up16:
	rts

slide_down16:		; long ; long[0000 et col]
	add.w	#1,tempo
	cmp.w	#3,tempo
	bne.B	no_end_up16
	clr.w	tempo

	move.w	slide_compt16,d0
	move.w	#31,d5
	move.l	#copp,a0
boucle16d:
	move.w	2(a0),d1
	and.w	#$000f,d1
	cmp.w	#0,d1
	beq.B	no_11d
	sub.w	#0001,2(a0)
no_11d:	move.w	2(a0),d1
	and.w	#$00f0,d1
	cmp.w	#0,d1
	beq.B	no_21d
	sub.w	#$0010,2(a0)
no_21d:	move.w	2(a0),d1
	and.w	#$0f00,d1
	cmp.w	#0,d1
	beq.B	no_31d
	Sub.w	#$0100,2(a0)
no_31d:
	add.l	#4,a0
	dbra	d5,boucle16d

	add.w	#1,slide_compt16
	cmp.w	#16,slide_compt16		
	bne.b	no_end_down16
	move.b	#0,slide_down_ok16
no_end_down16:
	rts
;---------------------------------------------------------------
SAVE_ALL:
	MOVE.B #$87,$BFD100		; STOP DRIVE
	MOVE.L $00000004,A6
	JSR -132(A6)

	MOVE.L $6C,SAVEIRQ
	MOVE.W $DFF01C,SAVEINT
	OR.W #$C000,SAVEINT
	MOVE.W $DFF002,SAVEDMA
	OR.W #$8100,SAVEDMA
	RTS
RESTORE_ALL:
	MOVE.L SAVEIRQ,$6C
	MOVE.W #$7FFF,$DFF09A	
	MOVE.W SAVEINT,$DFF09A
	MOVE.W #$7FFF,$DFF096
	MOVE.W SAVEDMA,$DFF096
	MOVE.L $00000004,A6
	LEA NAME,A1
	MOVEQ #0,D0
	JSR -552(A6)

	MOVE.L D0,A0
	MOVE.L 38(A0),$DFF080
	CLR.W $DFF088
	MOVE.L D0,A1
	JSR -414(A6)

	JSR -138(A6)
	RTS
;---------------------------------------------------------------
SAVEINT:DC.W 0
SAVEDMA:DC.W 0
SAVEIRQ:DC.L 0
NAME:DC.B "graphics.library",0
	EVEN

copp:
		DC.L	$01800000,$01820000,$01840000,$01860000,$01880000
		DC.L	$018A0000,$018C0000,$018E0000	; 8col
		DC.L	$01900000,$01920000,$01940000,$01960000,$01980000
		DC.L	$019A0000,$019C0000,$019E0000	; 8col

		DC.L	$01A00000,$01A20000,$01A40000,$01A60000,$01A80000
		DC.L	$01AA0000,$01AC0000,$01AE0000
		DC.L	$01B00000,$01B20000,$01B40000,$01B60000,$01B80000
		DC.L	$01BA0000,$01BC0000,$01BE0000

		dc.l	$00960020
		dc.l	$2801fffe

PT1:		DC.L	$00E00000,$00E20000
PT2:		DC.L	$00E40000,$00E60000
PT3:		DC.L	$00E80000,$00EA0000
PT4:		DC.L	$00Ec0000,$00Ee0000
PT5:		DC.L	$00f00000,$00f20000
		DC.L	$01005200

		DC.L	$009C8010,$FFFFFFFE	; END COPPER
;---------------------------------------------------------------
pic:		blk.b	51200,0
pal		blk.b	74,0
end_data:

		>extern	"df1:iff/menu1.bt",pic
		>extern	"df1:iff/menu1.pal",pal

